////////////////////////////////////////////////////////////////////
//
//  Tutorial uso di MySql con driver ODBC della actual technologies
//
//  Created by Francesco Germinara 
// 
//  Freeware (c) 2005 SofTech di F.Germinara - www.germinara.it. 
//
//  For information please contact me at info@germinara.it 
////////////////////////////////////////////////////////////////////
//  History:
//
//  Description:
//
////////////////////////////////////////////////////////////////////

#import "panelRicorrenzeController.h"

#import "NSString+FGString.h" //Expand NSString class using Categories
#import "FGBseData.h"         //manage Data field

@implementation panelRicorrenzeController


- (void) dealloc {
	[dsRicorrenze release];
	[super dealloc];
}


-(void) awakeFromNib{
  dsRicorrenze=[[FGODBCResultSet alloc] init:theApp SetIdentifier:@"RICORRENZE" tableView:elencoRicorrenze];
  
  [self setCtrlStat:TRUE]; //enable/disable control in user interface
  
  [elencoRicorrenze setTarget:self];
  [elencoRicorrenze setDoubleAction:@selector(loadSelectedData)]; //Double click
 
  
}

- (void)windowDidBecomeKey:(NSNotification *)aNotification{
 static int bOnlyOnce=0;
 if(!bOnlyOnce){
  [self startUseDataSource];
  bOnlyOnce=1;
 }
}

-(void) startUseDataSource{
 [elencoRicorrenze setDataSource:nil];
   //Execute the query for dataset result 
 [dsRicorrenze FillArray:theApp->pTabRicorrenze SqlFilter:@"order by ID_TIPO_RICOR" ProgressInd:nil]; 
 //Set datasource to tableview
 [elencoRicorrenze setDataSource:dsRicorrenze];
 }

- (IBAction)btnBarraAzionePremuto:(id)sender
{
 //Chiudo la finestra
 int nOperationToDo=0;
 nOperationToDo=[sender selectedSegment]; //Get the Button That is selected on the segment
 id aPanel=[sender window];
 
  if(nOperationToDo == 0){ //REGISTRA was pressed Insert/Modify the record
   [self updateRecord];
  
   [self startUseDataSource];    //refresh datasource 
   
   [self setCtrlStat:TRUE];
   
   [self clearFelds];
  }
  
 if(nOperationToDo == 1){ //CANCELLA was pressed Delete the record
	NSString *strInfo;
	strInfo=[NSString stringWithFormat:@"Do you want delete %@.  Are you sure ?",[[idRicorrenza stringValue]TrimRight]];
	int rc=NSRunAlertPanel(@"Warning!",strInfo,@"YES",@"NO",nil);
	if(rc==NSOKButton){	
     [self deleteRecord];
  
    [self startUseDataSource];    //refresh datasource 
	
	[self setCtrlStat:TRUE];
	 [self clearFelds];
   }
  }

 if(nOperationToDo == 2){ //ELIMINA TUTTI was pressed Delete all records
  NSString *strInfo;
  strInfo=[NSString stringWithString:@"Do you want remove all records. Are you sure ?"];
  int rc=NSRunAlertPanel(@"Warning!",strInfo,@"YES",@"NO",nil);
  if(rc==NSOKButton){	
   [self deleteAllRecords];
  
   [self startUseDataSource];    //refresh datasource 
   
   [self setCtrlStat:TRUE];
    [self clearFelds];
   }
  }
  
  if(nOperationToDo == 3){ //STAMPA was pressed Print all records
   [elencoRicorrenze print:self];
  }
 

 if(nOperationToDo == 4){      //ESCI was pressed close sheet  
  [self setCtrlStat:TRUE];
  [aPanel  orderOut:nil];      //Close the panel
  [NSApp endSheet:aPanel ];    //End the sheet loop
 }
 
}

- (IBAction)btnModificaPremuto:(id)sender
{

//1: Check if key field is valid
NSString *aString=[[idRicorrenza stringValue] TrimRight]; //Eliminate right blanks

if([aString isEqualToString:@""]){
 NSRunAlertPanel(@"ERROR",@"You must specify a valid id for recurrence type!",@"OK",nil,nil);
 return;
}

if([aString length] >4){
 NSRunAlertPanel(@"ERROR",@"Lenght must not exceed 4 character!",@"OK",nil,nil);
 return;
}

//2: Check if record already present
NSMutableString *strQuery;
strQuery=[NSMutableString stringWithFormat:@"WHERE ID_TIPO_RICOR='%@' ",aString]; //Build the query 

if([theApp->pTabRicorrenze LoadDati:strQuery] == TRUE){
 NSLog(@"Found: %@ in table RICORRENZE",aString);
 //Update info in user interface
 [descrizione setStringValue:[[theApp->pTabRicorrenze FieldInfo:@"DESCR"] GetValue]];
}else{
 NSLog(@"Not Found: %@ in table RICORRENZE",aString);
  //New record, clear fields
 [self clearFelds];
}

[self setCtrlStat:FALSE];

}

//Update Record
-(void)updateRecord{
NSMutableString *strQuery;
NSString *aString=[[idRicorrenza stringValue] TrimRight]; //Eliminate right blanks

strQuery=[NSMutableString stringWithFormat:@"WHERE ID_TIPO_RICOR='%@' ",aString]; //Build the query 
BOOL sts=[theApp->pTabRicorrenze LoadDati:strQuery]; //New Insert or Update ?

//Assign new data value for the record	
[[theApp->pTabRicorrenze FieldInfo:@"ID_TIPO_RICOR"] SetValue:aString];	
[[theApp->pTabRicorrenze FieldInfo:@"DESCR"] SetValue:[descrizione stringValue]];	
 	
 //If not exist make a INSERT else a UPDATE	
 if(sts==FALSE)
  [theApp->pTabRicorrenze Insert];
 else
  [theApp->pTabRicorrenze Update:strQuery];

}

//Delete Record
-(void)deleteRecord{
NSMutableString *strQuery;
NSString *aString=[[idRicorrenza stringValue] TrimRight]; //Eliminate right blanks

strQuery=[NSMutableString stringWithFormat:@"WHERE ID_TIPO_RICOR='%@' ",aString]; //Build the query 
[theApp->pTabRicorrenze Delete:strQuery]; 
}

//Delete all records
-(void)deleteAllRecords{
 [theApp->pTabRicorrenze Delete:@""]; 
}

//enable/disable control in user interface
-(void)setCtrlStat:(BOOL) bSts{

 [idRicorrenza setEnabled:bSts];
 [descrizione setEnabled:!bSts];
 
 [pulsantiAzione setEnabled:!bSts forSegment:0]; //Enable/Disable REGISTRA
 [pulsantiAzione setEnabled:!bSts forSegment:1]; //Enable/Disable CANCELLA
 [btnModifica setEnabled:bSts];
}

//Double click action
-(void)loadSelectedData{
 int nSelectedRow=[elencoRicorrenze clickedRow];
 FGODBCRecord *tmpRecord=[dsRicorrenze GetSingleRow:nSelectedRow];

 //Update info in user interface
 [idRicorrenza setStringValue:[[tmpRecord FieldInfo:@"ID_TIPO_RICOR"] GetValue]];
 [descrizione setStringValue:[[tmpRecord FieldInfo:@"DESCR"] GetValue]];

 [self setCtrlStat:FALSE];
}

//Clear user input fields data
-(void)clearFelds{
 [descrizione setStringValue:@""];
}

@end
